<?php

session_start();
require 'functions.php';

$info = [];
$info['success'] = false;
$info['LOGGED_IN'] = is_logged_in();
$info['data_type'] = $_POST['data_type'] ?? '';

if(!$info['LOGGED_IN'] && ($info['data_type'] != 'user_signup' && $info['data_type'] != 'user_login'))
{
	echo json_encode($info);
	die;
}

$info['username'] = $_SESSION['MY_DRIVE_USER']['username'] ?? 'User';
$info['drive_occupied'] = get_drive_space($_SESSION['MY_DRIVE_USER']['id']);
$info['drive_total'] = 10; //in GBs

if($_SERVER['REQUEST_METHOD'] == "POST" && !empty($_POST['data_type']))
{
	
	if($_POST['data_type'] == "upload_files")
	{
		$folder = 'uploads/';
		if(!file_exists($folder)){
			mkdir($folder,0777,true);
			file_put_contents($folder.".HTACCESS", "Options -Indexes");
		}

		foreach ($_FILES as $key => $file) {
			
			$destination = $folder. time() . $file['name'];
			if(file_exists($destination))
				$destination = $folder. time() . rand(0,9999) . $file['name'];

			move_uploaded_file($file['tmp_name'], $destination);

			//save to database
			$file_type = $file['type'];
			$date_created = date("Y-m-d H:i:s");
			$date_updated = date("Y-m-d H:i:s");
			$file_name = $file['name'];
			$file_path = $destination;
			$file_size = filesize($destination);
			$user_id = $_SESSION['MY_DRIVE_USER']['id'] ?? 0;
			$folder_id = $_POST['folder_id'] ?? 0;

			$query = "insert into mydrive 
			(file_name, file_size, file_path, user_id, file_type, date_created, date_updated, folder_id) 
			 values 
			('$file_name', '$file_size', '$file_path', '$user_id', '$file_type', '$date_created', '$date_updated', '$folder_id')";
			
			query($query);

			$info['success'] = true;
		}
	}else
	if($_POST['data_type'] == "new_folder")
	{

		//save to database
		$name = addslashes($_POST['name']);
		$date_created = date("Y-m-d H:i:s");
		$user_id = $_SESSION['MY_DRIVE_USER']['id'] ?? 0;
		$parent = $_POST['folder_id'] ?? 0;

		$query = "insert into folders (name, user_id, date_created, parent) values ('$name', '$user_id', '$date_created', '$parent')";
		query($query);

		$info['success'] = true;
		
	}else
	if($_POST['data_type'] == "user_logout")
	{
		if(isset($_SESSION['MY_DRIVE_USER']))
			unset($_SESSION['MY_DRIVE_USER']);

		$info['success'] = true;

	}else
	if($_POST['data_type'] == "user_signup")
	{
 
		//save to database
		$email = addslashes($_POST['email']);
		$username = addslashes($_POST['username']);
		$password = addslashes($_POST['password']);
		$retype_password = addslashes($_POST['retype_password']);
		$date_created = date("Y-m-d H:i:s");
		$date_updated = date("Y-m-d H:i:s");
		
		//validate data
		$errors = [];
		if(empty($username) || !preg_match("/^[a-zA-Z ]+$/",$username))
			$errors['username'] = "Invalid username. No symbols allowed";

		if(!filter_var($email, FILTER_VALIDATE_EMAIL))
			$errors['email'] = "Invalid email address";
		
		if(query("select id from users where email = '$email' limit 1"))
			$errors['email'] = "That email address already exists";

		if(empty($password))
			$errors['password'] = "A password is required";

		if(strlen($password) < 8)
			$errors['password'] = "Password must be at least 8 characters long";
		
		if($password !== $retype_password)
			$errors['password'] = "Passwords do not match";

		
		if(empty($errors))
		{

			$password = password_hash($password, PASSWORD_DEFAULT);

			$query = "insert into users 
			(username, email, password, date_created, date_updated) 
			 values 
			('$username', '$email', '$password', '$date_created', '$date_updated')";
			
			query($query);
			$info['success'] = true;
		}

		$info['errors'] = $errors;
		
	}else
	if($_POST['data_type'] == "user_login")
	{
 
		//save to database
		$email = addslashes($_POST['email']);
		$password = addslashes($_POST['password']);
		
		//validate data
		$errors = [];
		$row = query("select * from users where email = '$email' limit 1");
		if(!empty($row))
		{
			$row = $row[0];
			if(password_verify($password, $row['password'])){

				//all good
				$info['success'] = true;
				$_SESSION['MY_DRIVE_USER'] = $row;
			}
 
		}

		$info['errors']['email'] = "Wrong email or password";
		
	}else
	if($_POST['data_type'] == "get_files")
	{
 
 		$user_id = $_SESSION['MY_DRIVE_USER']['id'] ?? null;
 		$mode = $_POST['mode'];
 		$folder_id = $_POST['folder_id'] ?? 0;

 		switch ($mode) {
 			case 'MY DRIVE':
 				$query_folder = "select * from folders where user_id = '$user_id' && parent = '$folder_id' order by id desc limit 30";
 				$query = "select * from mydrive where user_id = '$user_id' && folder_id = '$folder_id' order by id desc limit 30";
 				break;

 			case 'FAVORITES':
 				$query = "select * from mydrive where favorite = 1 && user_id = '$user_id' order by id desc limit 30";
 				break;

 			case 'RECENT':
 				$query = "select * from mydrive where user_id = '$user_id' order by date_updated desc limit 30";
 				break;

 			case 'TRASH':
 				$query = "select * from mydrive where trash = 1 && user_id = '$user_id' order by id desc limit 30";
 				break;
 			
 			default:
 				$query = "select * from mydrive where user_id = '$user_id' && folder_id = '$folder_id' order by id desc limit 30";
 				break;
 		}

 		if(!empty($query_folder))
			$rows_folder = query($query_folder);
		
		if(empty($rows_folder))
			$rows_folder = [];

		$rows = query($query);
 		if(empty($rows))
			$rows = [];

		$rows = array_merge($rows_folder, $rows);
		if(!empty($rows))
		{
			foreach ($rows as $key => $row) {

				if(empty($row['file_type'])){

					$rows[$key]['file_type'] = 'folder';
					$row['file_type'] = 'folder';
					
					$rows[$key]['date_updated'] = $row['date_created'];
					$row['date_updated'] = $row['date_created'];
					
					$rows[$key]['file_size'] = 0;
					$row['file_size'] = 0;
					
					$rows[$key]['file_name'] = $row['name'];
					$row['file_name'] = $row['name'];
					
				}

				$parts = explode(".", $row['file_name']);
				$ext = strtolower(end($parts));
				$rows[$key]['icon'] = get_icon($row['file_type'], $ext);
				$rows[$key]['date_created'] = get_date($row['date_created']);
				$rows[$key]['date_updated'] = get_date($row['date_updated']);
				$rows[$key]['file_size'] = round($row['file_size'] / (1024 * 1024)) . "Mb";

				if($rows[$key]['file_size'] == "0Mb")
					$rows[$key]['file_size'] = round($row['file_size'] / (1024)) . "kb";
			}

			$info['rows'] = $rows;
			$info['success'] = true;
		}
	}
	

}

echo json_encode($info);
